/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.lo.scorm;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;

/**
 * zipファイルユーティリティー
 * 
 */
public class ScormContentsExtract {
	private File file;
	private ZipFile zipFile;
	private ZipEntry xmlEntry;
	private byte buf[];
	private static final int BUFFER_SIZE = 8092;

	/**
	 *コンストラクタ
	 */
	public ScormContentsExtract() {
	;
	}

	public static void main(String[] args) {
		if (args.length != 2){
            		System.out.println("ﾊﾟﾗﾒｰﾀｴﾗｰ!");
        	}
		try{
			ScormContentsExtract obj = new ScormContentsExtract();
	   		obj.saveAllEntries(args[0], args[1]);

		}
		catch(ZipException e){
		}
		catch(IOException e){
		}
   	}

	/**
	 * zipファイル内の全エントリを保存する
	 * @param filePath 展開元zip
	 * @param folderName 展開先フォルダ
	 * @throws IOException
	 *    [j] 入出力エラーが発生した場合
	 *    [e] if an I/O error has occured
	 */
	public boolean saveAllEntries(String filePath, String folderName) throws IOException {
		try{
			File file = new File(filePath);
			ZipFile zipFile = new ZipFile(file);
			buf = new byte[BUFFER_SIZE];

			String folderNameWithSlash;
			if(folderName.endsWith("/")) {
				folderNameWithSlash = folderName;
			} else {
				folderNameWithSlash = folderName + "/";
			}
			new File(folderNameWithSlash).mkdirs();
		
			Enumeration e = zipFile.entries();
			while(e.hasMoreElements()) {
				ZipEntry entry = (ZipEntry)e.nextElement();
				saveEntry(zipFile, folderNameWithSlash, entry);
			}
			return true;
		}
		catch(IOException e){
			return false;
		}
	}

	/**
	 * zipファイル内の指定されたエントリを指定されたフォルダに保存する
	 * @param zipFile zipFileオブジェクト
	 * @param folderName folder name to save the file
	 * @param entry ZipEntry to save
	 * @throws IOException
	 *   入出力エラーが発生した場合
	 */
	private void saveEntry(ZipFile zipFile, String folderName, ZipEntry entry) throws IOException {
		String name = entry.getName();
		String fullName = folderName;
		fullName = folderName + name;
		File file = new File(fullName);
		if(name.endsWith("/")) {
			// directory entry
			file.mkdirs();
			return;
		}
		file.getParentFile().mkdirs();
		FileOutputStream os = new FileOutputStream(fullName);
		InputStream is = zipFile.getInputStream(entry);
		int n = 0;
		while((n = is.read(buf)) > 0) {
			os.write(buf, 0, n);
		}
		is.close();
		os.close();
	}
	
	/**
	 * zipファイルをクローズする
	 * @throws IOException
	 *    [j] 入出力エラーが発生した場合
	 *    [e] if an I/O error has occured
	 */
	public void close() throws IOException {
		if(zipFile != null) {
			zipFile.close();
			zipFile = null;
		}
	}	
	
	/**
	 * Fileオブジェクトを取得する
	 * @return File object
	 */
	public File getFile() {
		return file;
	}

	/**
	 * zipファイル名を取得する
	 * @return zip file name
	 */
	public String getFileName() {
		if(file != null) {
			return file.getName();
		} else {
			return "";
		}
	}
	
	/**
	 *  zipファイル名の末尾の".zip"を除いたものを返す
	 * @return zip file name (without ".zip")
	 */
	public String getFileTitle() {
		String fileName = getFileName();
		if(fileName.length() < 4) {
			return fileName;
		} else {
			return fileName.substring(0, fileName.length() - 4);
		}
	}
	}
